#!/usr/bin/perl

# common values (for i_edit/i_save.cgi's)

$datadir    = '../html/imaging/temp';	   # server-side directory to keep the uploaded images
$piccat     = '/imaging/temp';             # URL of the uploaded image files
$tmpnam     = "tmp-$$";                    # name for the tmp file
$savescript = '/cgi-bin/i_save.cgi';       # URL of the script i_save.cgi
$viewscript = '/cgi-bin/i_view.cgi';       # URL of the script i_save.cgi
$appletdir  = '/imaging/product/applet';   # URL of the applet directory


# print header

	print "Content-type: text/html\n\n";

#
# It's only an example. There are no tests for the errors, and
# this is a very special upload processing routine and not efficient:
# we writes two files and loads all image staff to memory.
#
# The subroutines in the i_save.cgi are similar to those here.
# 

   $R = &getquery;
   
   if( ! $R->{len} )
   {
      unlink "$datadir/$tmpnam";
      &herror("Image not sent");
   }
   
	rename( "$datadir/$tmpnam" , "$datadir/$R->{fname}" );

# print answer

	&print_answer( 
		piccat   	=> $piccat, 
		file     	=> $R->{fname},
		new_file 	=> "new_".$R->{fnameb}.'.jpg', # the result is JPEG, always.
		savescript 	=> $savescript,
		appletdir  	=> $appletdir,
		finw       	=> $R->{finwidth},
		finh       	=> $R->{finheight},
	);
	
exit; 

############ s u b s #########	

#
# prints message to output page, exits. 
#

sub herror
{
   print "<hr>".$_[0];
   exit;
}

#
# get all neccessary data from input.
# image is to be saved to the tmp file (global variable).
#

sub getquery
{
   my $R = {};

   if( $ENV{CONTENT_TYPE} !~ /multipart/ )
   {
      &herror("Illegal call to application : multipart form data required");
   }

# save upload to tmp file

	open(W,">$datadir/$tmpnam");
	binmode(W);
	binmode(STDIN);
	print W while(<STDIN>); 
	close(W);

   if(0) # can be set to TRUE for debug purposes
   {
	   open(R,"$datadir/$tmpnam");
   	open(W,">$datadir/$tmpnam-1");
	   binmode(W);
	   binmode(R);
	   print W while(<R>); 
	   close(W);
	   close(R);
   }

# process upload

	$R = &parse_upload( "$datadir/$tmpnam" );
	$R;
}

#
# print output. Here we have only one kind of output page.
#

sub print_answer
{
	my %a = @_;

	print <<EOT;
<html>

<head>
<title>Net Imaging. Process the uploaded image.</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>

<body bgcolor="#A8A8B8">
EOT


	print <<EOT;
<table border="0" cellpadding="8"><tr><td>

<applet width="500" height="500"
	codebase="$a{appletdir}/" archive="imaging.jar" code="Main.class">
	
  <param name="load" value="$a{piccat}/$a{file}">
  <param name="save" value="$a{savescript}" >
  <param name="filename" value="$a{piccat}/$a{new_file}" >
EOT

	if( $a{finw} && $a{finh} )
	{
		print <<EOT;
    <!-- The parameters for final image scaling -->
    <param name="proportion" value="$a{finw},$a{finh}">
    <param name="minsize" value="$a{finw},$a{finh}">
    <param name="scaleto" value="$a{finw},$a{finh}">
EOT
	}

	print <<EOT;
</applet>

</td>
<td valign="top">

<p>
Now the image has been uploaded to the server and the applet have loaded
it back from the server for processing.<br>
</p>

<p>
If you press the button <img src="$a{appletdir}/images/save.gif" border="0" alt="save"> the applet will upload
the processed image to the server. The script &quot;i_save.cgi&quot; is going to process this new upload.
</p>

</td></tr></table>

</body>
</html>
EOT


}

#
# processing upload. In a very inefficient way.
#


sub parse_upload # (filename)
{
   my $f = shift;
   my $r = {}; # what to return 
   
   my ($delimiter,$D,@D,$n);

# get delimiter. The input is the image and variables separated by delimiter.
# delimiter can be read from CONTENT_TYPE too.

   open(R,$f)||return(undef);
   binmode(R);
   $delimiter = <R>; $delimiter =~ s/\s+$//;
   seek(R,0,0);
   
   $D = ''; while(<R>) { $D .= $_; } # read all to $D
   close(R);

   @D = split(/$delimiter/,$D); # split to very big chunks
   
   # empty - file - finwidth - finheight #
   
# 1) file
   
   $D[1] =~ /\x0D\x0A\x0D\x0A/;
   $n = $`;
   $D[1] = $';
   $r->{len} = length($D[1])-2;
   $D[1] = substr($D[1],0,$r->{len});
   
# 1.1) filename
   
   $n =~ /filename=\"([^\"]+)\"/; $n = $1;
   $n =~ /([^\\\/]+)$/;
   $r->{fname} = $1;

   $r->{fname} =~ s/[^A-Za-z0-9\.\-\_]/_/g; # don't want strange letters here
   
   $r->{fname} =~ /\.([^\.]*)$/;
   $r->{fnameb} = $`;
   $r->{fnamex} = $1;
   
# 2 and 3) fin* - get variables
   
   &get_uplovar($r,$D[2]);
   &get_uplovar($r,$D[3]);
   
# save picture to the same tmp-file
   
   open(W,">$f"); binmode(W); print W $D[1]; close(W);
   
   $r;

}

#
# get varibale from data chunk. It's not image body.
#

sub get_uplovar
{
   my $r = shift;
   my $s = shift;
   if(  $s !~ /name=\"([^\"]*)\"/ )
   {
      &herror("data not found in the input");
   }
   my $n = $1;
   $s =~ /\x0D\x0A\x0D\x0A(\S*)\x0D\x0A/;
   $r->{$n} = $1;
}

